## mysql-workbench 8.0.17+dfsg

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.5 FATAL_ERROR)

# Detect build type, fallback to release and throw a warning if use didn't specify any
if(NOT CMAKE_BUILD_TYPE)
  message(WARNING "Build type not set, falling back to Release mode.
 To specify build type use:
 -DCMAKE_BUILD_TYPE=<mode> where <mode> is Debug or Release.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
       "Choose the type of build, options are: Debug Release RelWithDebInfo"
       FORCE)
endif(NOT CMAKE_BUILD_TYPE)


# Retrieve current Workbench version
execute_process(COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/tools/get_wb_version.sh full_version
                OUTPUT_VARIABLE WB_VERSION)

string(STRIP ${WB_VERSION} WB_VERSION)

project(WORKBENCH LANGUAGES C CXX)

option(ENABLE_COTIRE "Enable cotire to generate precompiled headers" OFF)
option(TEST_BUILD "Enable building additonal debug libs" OFF)
option(BUILD_FOR_GCOV "Enable gcov instrumentation" OFF)
option(USE_BUNDLED_MYSQL "Use bundled MySQL tools" OFF)


#  About MySQL and CMake
#  http://dev.mysql.com/doc/internals/en/autotools-to-cmake.html
#  http://www.lenzg.net/archives/291-Building-MySQL-Server-with-CMake-on-LinuxUnix.html

#-----------------------------------------------------------------------
# Find packages and other useful checks
#-----------------------------------------------------------------------

# Look for our custom modules in cmake/Modules:
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/build/cmake/Modules/")

if(ENABLE_COTIRE)
  include(cotire)
  set_property(DIRECTORY PROPERTY COTIRE_UNITY_LINK_LIBRARIES_INIT "COPY_UNITY")
endif()


find_package(PkgConfig REQUIRED)
find_package(Java QUIET)
find_package(X11 REQUIRED)
find_package(Threads REQUIRED)
find_package(SWIG REQUIRED)
include(${SWIG_USE_FILE})
find_package(ANTLR4 REQUIRED)

pkg_check_modules(GTK3 REQUIRED gtk+-3.0)
pkg_check_modules(GTKMM REQUIRED gtkmm-3.0)
pkg_check_modules(GTHREAD REQUIRED gthread-2.0)
pkg_check_modules(GMODULE REQUIRED gmodule-2.0)
pkg_check_modules(GLIB REQUIRED glib-2.0>=2.30)

if (USE_BUNDLED_MYSQLDUMP)
  set(USE_BUNDLED_MYSQLDUMP -DHAVE_BUNDLED_MYSQLDUMP=1)
endif ()

# In Ubuntu 13.04, the built-in check for python fails.. so we have to resort to the check with pkg-config (which doesn't work in many distros)
find_package(PythonLibs 2.6)
if (NOT PYTHONLIBS_FOUND)
    pkg_check_modules(PYTHON REQUIRED python)
endif ()


# We need to be able to detect python module versions and packages hence this function
find_program(PYTHON_EXEC "python2")
include(FindPackageHandleStandardArgs)

find_package(MySQL 5.6.0 REQUIRED)
find_package(LibXml2 REQUIRED)
#set(OpenGL_GL_PREFERENCE "LEGACY")
find_package(OpenGL REQUIRED)
find_package(MySQLCppConn 1.1.8 REQUIRED)
find_package(VSqlite REQUIRED)
find_package(GDAL REQUIRED)
find_package(Boost REQUIRED)
find_package(LibSSH 0.8.5 REQUIRED)
find_package(OpenSSL REQUIRED)

if (UNIX)
  option(USE_UNIXODBC "Use unixODBC instead of iODBC" OFF)
  find_package(IODBC)
  find_package(UNIXODBC)
  if (USE_UNIXODBC)
    if (UNIXODBC-NOTFOUND)
      message(FATAL_ERROR "You've selected Unixodbc, but it cannot be found, CMake will exit.")
    else()
		  set(ODBC_LIBRARIES ${UNIXODBC_LIBRARIES})
  		set(ODBC_INCLUDE_DIRS ${UNIXODBC_INCLUDE_DIRS})
	  	set(ODBC_DEFINITIONS ${UNIXODBC_DEFINITIONS})
    endif()
  else()
    if (IODBC_FOUND)
      message("Found iodbc, using it as ODBC library.")
      set(ODBC_LIBRARIES ${IODBC_LIBRARIES})
      set(ODBC_INCLUDE_DIRS ${IODBC_INCLUDE_DIRS})
      set(ODBC_DEFINITIONS ${IODBC_DEFINITIONS})
    elseif (UNIXODBC_FOUND)
      message("Found unixodbc, using it as ODBC library.")
      set(ODBC_LIBRARIES ${UNIXODBC_LIBRARIES})
      set(ODBC_INCLUDE_DIRS ${UNIXODBC_INCLUDE_DIRS})
      set(ODBC_DEFINITIONS ${UNIXODBC_DEFINITIONS})
    else()
      message(FATAL_ERROR "Workbench required iodbc or Unixodbc, none was found, CMake will exit.")
    endif()
  endif(USE_UNIXODBC)
endif(UNIX)


pkg_check_modules(PCRE REQUIRED libpcre libpcrecpp)
pkg_check_modules(CAIRO REQUIRED cairo>=1.5.12)
pkg_check_modules(UUID REQUIRED uuid)
pkg_check_modules(LIBZIP REQUIRED libzip)
if (UNIX)
  pkg_check_modules(LIBSECRET REQUIRED libsecret-1)
	if (LIBSECRET_FOUND)
		set(KEYRING_DEFINITION     "HAVE_LIBSECRET_KEYRING")
	endif()
endif()

if (UNIX)
  include (CheckIncludeFiles)
  CHECK_INCLUDE_FILES ("sys/prctl.h" HAVE_PRCTL)
endif()

include (CheckFunctionExists)
check_function_exists (strtol HAVE_STRTOL)
check_function_exists (strtoll HAVE_STRTOLL)
check_function_exists (strtold HAVE_STRTOLD)
check_function_exists (strtoull HAVE_STRTOULL)
check_function_exists (strtoimax HAVE_STRTOIMAX)
check_function_exists (strtoumax HAVE_STRTOUMAX)

set(ANTLR_JAR_FILENAME "antlr-4.7.1-complete.jar")
get_filename_component(SOURCE_PARENT_DIR ${CMAKE_SOURCE_DIR} DIRECTORY)
set(LINUX_RES_BIN_DIR ${SOURCE_PARENT_DIR}/linux-res/bin)
if(WITH_ANTLR_JAR)
  get_filename_component(ANTLR_JAR_USER_DIR ${WITH_ANTLR_JAR} DIRECTORY)
  find_path(ANTLR_JAR_PATH ${ANTLR_JAR_FILENAME} ${LINUX_RES_BIN_DIR} ${ANTLR_JAR_USER_DIR})
else(WITH_ANTLR_JAR)
  find_path(ANTLR_JAR_PATH ${ANTLR_JAR_FILENAME} ${LINUX_RES_BIN_DIR})
endif(WITH_ANTLR_JAR)
if(ANTLR_JAR_PATH AND Java_JAVA_EXECUTABLE) 
  set(ANTLR_JAR_PATH ${ANTLR_JAR_PATH}/${ANTLR_JAR_FILENAME})
  message(STATUS "ANTLR jar: " ${ANTLR_JAR_PATH})
else()
  message(WARNING ${ANTLR_JAR_FILENAME} " or java runtime wasn't found which is required if you'd like to rebuild Lexer and Parser files")
endif()


if (UNIX)
	if (NOT LIB_INSTALL_DIR)
		set(LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib")
	endif()
	if (NOT SHARE_INSTALL_PREFIX)
		set(SHARE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/share")
	endif()
	if (NOT ETC_INSTALL_DIR)
		set(ETC_INSTALL_DIR "/etc")
	endif()
	if (NOT REAL_EXECUTABLE_DIR)
		set(REAL_EXECUTABLE_DIR "${CMAKE_INSTALL_PREFIX}/bin")
	endif()

	set(WB_INSTALL_DIR              "${CMAKE_INSTALL_PREFIX}")
	set(WB_INSTALL_DIR_EXECUTABLE   "${REAL_EXECUTABLE_DIR}")
	set(WB_INSTALL_BIN_DIR          "${CMAKE_INSTALL_PREFIX}/bin")
	set(WB_INSTALL_LIB_DIR          "${LIB_INSTALL_DIR}/mysql-workbench")
	set(WB_PYTHON_MODULES_DIR       "${WB_INSTALL_LIB_DIR}/modules")
	set(WB_INSTALL_SHARED_DIR       "${SHARE_INSTALL_PREFIX}")
	set(WB_INSTALL_ETC_DIR          "${ETC_INSTALL_DIR}")
	set(WB_PACKAGE_SHARED_DIR       "${SHARE_INSTALL_PREFIX}/mysql-workbench")
	set(WB_PACKAGE_PLUGINS_DIR      "${LIB_INSTALL_DIR}/mysql-workbench/plugins")
	set(WB_PYTHON_MODULES_DATA_DIR  "${SHARE_INSTALL_PREFIX}/mysql-workbench/modules/data")
	set(WB_INSTALL_DOC_DIR          "${SHARE_INSTALL_PREFIX}/doc/mysql-workbench")
endif()

include(ExternalProject)

add_definitions(-D__STDC_FORMAT_MACROS)
add_definitions(-DGTK_DISABLE_SINGLE_INCLUDES)
add_definitions(-DGDK_DISABLE_DEPRECATED)
add_definitions(-DGTK_DISABLE_DEPRECATED)

set(BUILD_SHARED_LIBS ON)  # By default all libs will be built as shared libs
# SET(GCOV OFF CACHE BOOL "Add gcov flags")

# Determine std c++ version
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL "5.0" OR CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "5.0")
    set(CMAKE_CXX_STANDARD 14)
  endif()
elseif ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
  set(CMAKE_CXX_STANDARD 11)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "4.7")
    message(FATAL_ERROR "Insufficient gcc version. You need gcc v4.7 or newer to build this project")
  elseif(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "5.0")
    message("Using C++11 standard")
    set(CMAKE_CXX_STANDARD 11)
  elseif(CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL "5.0" OR CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "5.0")
    message("Using C++14 standard")
    set(CMAKE_CXX_STANDARD 14)
  endif()
  # C++17 requires gcc7
endif()



set(WB_CXXFLAGS -Werror -Wall -Wextra -Wno-unused-parameter -Wno-deprecated -Wno-deprecated-copy)
set(WB_CFLAGS -Werror -Wall -Wextra -Wno-unused-parameter -Wno-deprecated -Wno-deprecated-copy)

if(BUILD_FOR_GCOV)
    message ("Enable GCOV due to BUILD_FOR_GCOV")
    set(WB_CXXFLAGS ${WB_CXXFLAGS} -fprofile-arcs -ftest-coverage)
    set(WB_CFLAGS ${WB_CFLAGS} -fprofile-arcs -ftest-coverage)
endif()

#-----------------------------------------------------------------------
# Define some useful variables and options
#-----------------------------------------------------------------------
configure_file(${PROJECT_SOURCE_DIR}/mysql-workbench.desktop.in mysql-workbench.desktop)

add_subdirectory(tools)
add_subdirectory(backend)
add_subdirectory(ext)
add_subdirectory(frontend)
add_subdirectory(images)
add_subdirectory(library)
add_subdirectory(modules)
add_subdirectory(plugins)
add_subdirectory(res)
if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/internal)
  add_subdirectory(internal)
endif()

install(FILES ${CMAKE_BINARY_DIR}/mysql-workbench.desktop DESTINATION ${WB_INSTALL_SHARED_DIR}/applications)

if (IS_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/internal)
    install(FILES README-commercial.md License-commercial.txt DESTINATION ${WB_INSTALL_DOC_DIR})
else()
    install(FILES README.md License.txt DESTINATION ${WB_INSTALL_DOC_DIR})
endif()
install(FILES build/mysql-workbench-commercial.sharedmimeinfo DESTINATION ${WB_INSTALL_SHARED_DIR}/mime/packages RENAME mysql-workbench.xml)
install(FILES build/mysql-workbench-commercial.mime DESTINATION ${WB_INSTALL_SHARED_DIR}/mime-info RENAME mysql-workbench.mime)


install(FILES build/build_freetds.sh
        PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ WORLD_EXECUTE WORLD_READ
        DESTINATION ${WB_PACKAGE_SHARED_DIR}/extras)

install(FILES samples/models/sakila_full.mwb
        DESTINATION ${WB_PACKAGE_SHARED_DIR}/extras)

=== backend/wbprivate/CMakeLists.txt ===
add_library(wbprivate
    model/canvas_floater.cpp
    model/mini_view.cpp
    model/relationship_canvas_floater.cpp
    model/wb_catalog_tree_view.cpp
    model/wb_component.cpp
    model/wb_component_basic.cpp
    model/wb_component_logical.cpp
    model/wb_component_physical.cpp
    model/wb_component_physical_relationship.cpp
    model/wb_context_model.cpp
    model/wb_diagram_options.cpp
    model/wb_layer_tree.cpp
    model/wb_model_diagram_form.cpp
    model/wb_overview_diagram.cpp
    model/wb_overview_physical.cpp
    model/wb_overview_physical_schema.cpp
    model/wb_overview_privileges.cpp
    model/wb_physical_model_diagram_features.cpp
    model/wb_user_datatypes.cpp
    model/wb_history_tree.cpp
    model/wb_template_list.cpp
    sqlide/db_sql_editor_history_be.cpp
    sqlide/db_sql_editor_log.cpp
    sqlide/wb_sql_editor_form.cpp
    sqlide/wb_sql_editor_buffer.cpp
    sqlide/wb_sql_editor_form_ui.cpp
    sqlide/wb_sql_editor_help.cpp
    sqlide/wb_sql_editor_tree_controller.cpp
    sqlide/execute_routine_wizard.cpp
    sqlide/wb_sql_editor_panel.cpp
    sqlide/wb_sql_editor_result_panel.cpp
    sqlide/wb_context_sqlide.cpp
    sqlide/result_form_view.cpp
    sqlide/wb_live_schema_tree.cpp
    sqlide/wb_sql_editor_snippets.cpp
    sqlide/query_side_palette.cpp
    sqlide/spatial_data_view.cpp
    sqlide/spatial_draw_box.cpp
    workbench/metaclasses.cpp
    workbench/upgrade_helper.cpp
    workbench/wb_command_ui.cpp
    workbench/wb_context_ui.cpp
    workbench/wb_context_ui_home.cpp
    workbench/wb_context.cpp
    workbench/wb_model_file.cpp
    workbench/wb_model_file_upgrade.cpp
    workbench/wb_module.cpp
    workbench/wb_tunnel.cpp
    workbench/wb_overview.cpp
    workbench/wb_tunnel.cpp
    workbench/wb_db_schema.cpp
    workbench/about_box.cpp
    workbench/SSHSessionWrapper.cpp
    workbench/SSHFileWrapper.cpp
    workbench/license_view.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/new_server_instance_wizard.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/preferences_form.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/new_connection_wizard.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/document_properties_form.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/user_defined_type_editor.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/grt_shell_window.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/grt_code_editor.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/plugin_manager_window.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/plugin_install_window.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/select_option_dialog.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/snippet_list.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/server_instance_editor.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/grt_python_debugger.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/advanced_sidebar.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/snippet_popover.cpp
    ${PROJECT_SOURCE_DIR}/frontend/common/grt_plugin_wizard.cpp
)

target_compile_definitions(wbprivate PRIVATE USE_BUNDLED_MYSQLDUMP)

target_include_directories(wbprivate
  PRIVATE
    ${PROJECT_SOURCE_DIR}/generated
    ${PROJECT_SOURCE_DIR}/modules
    ${PROJECT_SOURCE_DIR}/frontend/common/
)

target_compile_options(wbprivate PRIVATE ${WB_CXXFLAGS})

target_link_libraries(wbprivate
  PUBLIC
    ${GDAL_LIBRARIES}
    wbprivate_Iface
  PRIVATE
    grt
    mdcanvas
    wbssh
    cdbc
    parsers
    mforms
    wbpublic::wbpublic
)

add_library(wbprivate_Iface INTERFACE)
add_library(wbprivate::wbprivate ALIAS wbprivate_Iface)

target_include_directories(wbprivate_Iface INTERFACE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)

target_include_directories(wbprivate_Iface
 SYSTEM INTERFACE
    ${VSQLITE_INCLUDE_DIRS}
    ${GDAL_INCLUDE_DIRS}
)

add_dependencies(wbprivate generate_parser_mysql)


if(BUILD_FOR_GCOV)
  target_link_libraries(wbprivate PRIVATE gcov)
endif()

set_target_properties(wbprivate
                      PROPERTIES VERSION   ${WB_VERSION}
                      SOVERSION ${WB_VERSION})

if(COMMAND cotire)
  set_target_properties(wbprivate PROPERTIES
    COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

  cotire(wbprivate)
endif()
install(TARGETS wbprivate DESTINATION ${WB_INSTALL_LIB_DIR})

=== library/base/CMakeLists.txt ===
add_library(wbbase 
    accessibility.cpp
    util_functions.cpp 
    data_types.cpp
    sqlstring.cpp 
    file_functions.cpp 
    file_utilities.cpp 
    threaded_timer.cpp 
    string_utilities.cpp 
    geometry.cpp 
    notifications.cpp 
    ui_form.cpp 
    config_file.cpp 
    drawing.cpp 
    log.cpp 
    threading.cpp 
    profiling.cpp
    jsonparser.cpp
    drawing_gtk.cpp
    boost_fix.cpp
    utf8string.cpp
    xml_functions.cpp
    symbol-info.cpp
)

target_include_directories(wbbase 
 SYSTEM
  PRIVATE
    ${GTKMM_INCLUDE_DIRS}
    ${PROJECT_SOURCE_DIR}/res

)

target_compile_options(wbbase PRIVATE ${WB_CXXFLAGS})
target_compile_definitions(wbbase PUBLIC __STDC_FORMAT_MACROS)

target_link_libraries(wbbase
  PUBLIC
    wbbase::wbbase
  PRIVATE
    wbprivate::wbprivate
    ${GLIB_LIBRARIES}
    ${GTK3_LIBRARIES}
    ${GTKMM_LIBRARIES}
) 

add_library(wbbase_Iface INTERFACE)
add_library(wbbase::wbbase ALIAS wbbase_Iface)
target_include_directories(wbbase_Iface INTERFACE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/library/base>
)

target_include_directories(wbbase_Iface 
 SYSTEM INTERFACE
    ${PYTHON_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
    ${LIBXML2_INCLUDE_DIR}
)
target_link_libraries(wbbase_Iface
  INTERFACE
    Boost::boost
) 


set_source_files_properties(drawing_gtk.cpp PROPERTIES COMPILE_FLAGS -Wno-pragmas)

if(BUILD_FOR_GCOV)
  target_link_libraries(wbbase PRIVATE gcov)
endif()

if(COMMAND cotire)
set_target_properties(wbbase PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")
cotire(wbbase)
endif()

set_target_properties(wbbase
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

install(TARGETS wbbase DESTINATION ${WB_INSTALL_LIB_DIR})

=== library/forms/CMakeLists.txt ===
add_subdirectory(swig)

set(DATA_FILES
    gtk/embedded_find.glade
)

install(FILES ${DATA_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR})

add_library(mforms
    app.cpp
    appview.cpp
    base.cpp
    box.cpp
    button.cpp
    canvas.cpp
    checkbox.cpp
    code_editor.cpp
    container.cpp
    dockingpoint.cpp
    drawbox.cpp
    filechooser.cpp
    find_panel.cpp
    form.cpp
    fs_object_selector.cpp
    gtk/src/active_label.cpp
    gtk/src/lf_box.cpp
    gtk/src/lf_button.cpp
    gtk/src/lf_code_editor.cpp
    gtk/src/lf_drawbox.cpp
    gtk/src/lf_find_panel.cpp
    gtk/src/lf_form.cpp
    gtk/src/lf_hypertext.cpp
    gtk/src/lf_label.cpp
    gtk/src/lf_listbox.cpp
    gtk/src/lf_menu.cpp
    gtk/src/lf_menubar.cpp
    gtk/src/lf_mforms.cpp
    gtk/src/lf_native.cpp
    gtk/src/lf_panel.cpp
    gtk/src/lf_popover.cpp
    gtk/src/lf_popup.cpp
    gtk/src/lf_radiobutton.cpp
    gtk/src/lf_scrollpanel.cpp
    gtk/src/lf_selector.cpp
    gtk/src/lf_splitter.cpp
    gtk/src/lf_tabview.cpp
    gtk/src/lf_textbox.cpp
    gtk/src/lf_textentry.cpp
    gtk/src/lf_table.cpp
    gtk/src/lf_toolbar.cpp
    gtk/src/lf_treeview.cpp
    gtk/src/lf_utilities.cpp
    gtk/src/lf_view.cpp
    gtk/src/lf_wizard.cpp
    gtk/src/mforms_acc.cpp
    hypertext.cpp
    imagebox.cpp
    label.cpp
    listbox.cpp
    menu.cpp
    menubar.cpp
    mforms.cpp
    native.cpp
    panel.cpp
    password_cache.cpp
    popover.cpp
    popup.cpp
    progressbar.cpp
    radiobutton.cpp
    gridview.cpp
    scrollpanel.cpp
    sectionbox.cpp
    selector.cpp
    simpleform.cpp
    splitter.cpp
    table.cpp
    tabswitcher.cpp
    tabview.cpp
    tabview_dock.cpp
    task_sidebar.cpp
    textbox.cpp
    textentry.cpp
    toolbar.cpp
    treeview.cpp
    utilities.cpp
    view.cpp
    jsonview.cpp
    widgets.cpp
    wizard.cpp
    jsonview.cpp
    home_screen.cpp
    home_screen_connections.cpp
    home_screen_documents.cpp
    home_screen_helpers.cpp
)

target_include_directories(mforms 
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/mforms
)

target_include_directories(mforms 
 SYSTEM
  PRIVATE
    ${LIBSECRET_INCLUDE_DIRS}
)


if (KEYRING_DEFINITION)
  target_compile_definitions(mforms PRIVATE HAVE_LIBSECRET_KEYRING)
endif()

target_compile_definitions(mforms PRIVATE $<$<CXX_COMPILER_ID:GNU>:SCI_NAMESPACE> __STDC_FORMAT_MACROS)
target_compile_options(mforms PRIVATE ${WB_CXXFLAGS})

if (HAVE_PRCTL)
  target_compile_definitions(mforms PRIVATE HAVE_PRCTL_H)
endif()


target_link_libraries(mforms
  PUBLIC
    mforms_Iface
  PRIVATE 
    linux_utilities 
    wbpublic::wbpublic
    mdcanvasgtk 
    mdcanvas
    parsers::parsers
)

add_library(mforms_Iface INTERFACE)
add_library(mforms::mforms ALIAS mforms_Iface)
target_include_directories(mforms_Iface INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<$<PLATFORM_ID:Linux>:${PROJECT_SOURCE_DIR}/library/forms/gtk/src>
)

target_link_libraries(mforms_Iface INTERFACE
    ${LIBSECRET_LIBRARIES}
    wbbase
    wbscintilla
)


set_source_files_properties(gtk/src/mforms_acc.cpp PROPERTIES COMPILE_FLAGS -Wno-pragmas)

if(BUILD_FOR_GCOV)
  target_link_libraries(mforms PRIVATE gcov)
endif()

set_target_properties(mforms
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

if(COMMAND cotire)
    set_target_properties(mforms PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

  cotire(mforms)
endif()

install(TARGETS mforms DESTINATION ${WB_INSTALL_LIB_DIR})

=== library/parsers/CMakeLists.txt ===
set(GENERATED_SOURCES
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLLexer.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParserBaseListener.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParserBaseVisitor.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParser.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParserListener.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParserVisitor.cpp
)

set(GENERATED_OTHERS
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLLexer.h
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLLexer.tokens
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParserBaseListener.h
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParserBaseVisitor.h
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParser.h
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParserListener.h
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParser.tokens
  ${CMAKE_CURRENT_SOURCE_DIR}/mysql/MySQLParserVisitor.h
)

set (GENERATED_FILES ${GENERATED_OTHERS} ${GENERATED_SOURCES})

add_custom_command(OUTPUT ${GENERATED_FILES} 
          DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/grammars/MySQLLexer.g4 ${CMAKE_CURRENT_SOURCE_DIR}/grammars/MySQLParser.g4
          COMMAND ${Java_JAVA_EXECUTABLE} -Xmx1024m -jar ${ANTLR_JAR_PATH} -Dlanguage=Cpp -listener -visitor -o ../mysql -package parsers ${CMAKE_CURRENT_SOURCE_DIR}/grammars/MySQLLexer.g4 ${CMAKE_CURRENT_SOURCE_DIR}/grammars/MySQLParser.g4
          WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/grammars
          COMMENT "[mysql] Generating parser files..."
          )


add_custom_target(generate_parser_mysql
                  ALL
                  DEPENDS ${GENERATED_FILES})

set_source_files_properties(${GENERATED_FILES} PROPERTIES GENERATED TRUE)

set(PARSERS_SOURCES
    ${GENERATED_SOURCES}
    mysql/MySQLBaseLexer.cpp
    mysql/MySQLBaseRecognizer.cpp
    mysql/MySQLRecognizerCommon.cpp
    parsers-common.cpp
    SymbolTable.cpp
    code-completion/CodeCompletionCore.cpp
    code-completion/mysql-code-completion.cpp
)

add_library(parsers
  ${PARSERS_SOURCES}
)



target_compile_options(parsers PRIVATE $<$<CXX_COMPILER_ID:GNU>:-Wno-sign-compare -Wno-type-limits -Wno-unused -Wno-missing-field-initializers -Wno-implicit-fallthrough>)

set(NEW_WB_CFLAGS ${WB_CFLAGS})
list(REMOVE_ITEM NEW_WB_CFLAGS -Werror)
target_compile_options(parsers PRIVATE ${NEW_WB_CFLAGS})

add_dependencies(parsers
    generate_parser_mysql)

target_link_libraries(parsers 
  PUBLIC 
   parsers_Iface
  PRIVATE 
   wbbase::wbbase
   ${GTK3_LIBRARIES})

if(BUILD_FOR_GCOV)
  target_link_libraries(parsers PRIVATE gcov)
endif()

add_library(parsers_Iface INTERFACE)
add_library(parsers::parsers ALIAS parsers_Iface)

target_include_directories(parsers_Iface INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_include_directories(parsers_Iface
 SYSTEM INTERFACE
    ${ANTLR4_INCLUDE_DIRS}
)

target_link_libraries(parsers_Iface INTERFACE
   ${ANTLR4_LIBRARIES}
) 


set_target_properties(parsers
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})
if(COMMAND cotire)
    set_target_properties(parsers PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

  cotire(parsers)
endif()

install(TARGETS parsers DESTINATION ${WB_INSTALL_LIB_DIR})

=== library/ssh/CMakeLists.txt ===
add_library(wbssh 
    SSHSftp.cpp
    SSHCommon.cpp
    SSHSession.cpp
    SSHTunnelHandler.cpp
    SSHTunnelManager.cpp
)

target_include_directories(wbssh
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
)

target_include_directories(wbssh
 SYSTEM
  PUBLIC
    $<BUILD_INTERFACE:${LibSSH_INCLUDE_DIRS}>
)


target_compile_options(wbssh PRIVATE ${WB_CXXFLAGS})

target_link_libraries(wbssh 
  PUBLIC 
    ${LibSSH_LIBRARIES} 
  PRIVATE 
    wbbase
)

if(BUILD_FOR_GCOV)
  target_link_libraries(wbssh PRIVATE gcov)
endif()

if(COMMAND cotire)
set_target_properties(wbssh PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")
cotire(wbssh)
endif()

set_target_properties(wbssh
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

install(TARGETS wbssh DESTINATION ${WB_INSTALL_LIB_DIR})

=== modules/db.mysql/CMakeLists.txt ===
set(PY_FILES 
    db_mysql_re_grt.py
    db_mysql_fe_grt.py
    db_mysql_migration_grt.py
)
install(FILES ${PY_FILES} DESTINATION ${WB_PYTHON_MODULES_DIR})

set(MODULE_DATA_FILES
    res/mysql_engines.xml
    res/mysql_rdbms_info.xml
    res/mysql_reserved.xml
)
install(FILES ${MODULE_DATA_FILES} DESTINATION ${WB_PYTHON_MODULES_DATA_DIR})

set(BASIC_FILES
    res/db_mysql_catalog_reporting/Basic_Text.tpl/basic_text_report.txt.tpl
)
install(FILES ${BASIC_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/modules/data/db_mysql_catalog_reporting/Basic_Text.tpl)

add_library(db.mysql.grt
    src/db_mysql_catalog_report.cpp
    src/db_mysql_diffsqlgen.cpp
    src/db_mysql_params.cpp
    src/module_db_mysql.cpp
)

target_include_directories(db.mysql.grt
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/src>
  PRIVATE
    ${PROJECT_SOURCE_DIR}/library
    ${PROJECT_SOURCE_DIR}/modules
)

target_link_libraries(db.mysql.grt 
  PRIVATE 
    wbpublic
    grt
    wbbase
    parsers
    mtemplate
    Boost::boost
)

if(BUILD_FOR_GCOV)
  target_link_libraries(db.mysql.grt PRIVATE gcov)
endif()

set_target_properties(db.mysql.grt
                      PROPERTIES PREFIX    ""
                                 VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

if(COMMAND cotire)
    set_target_properties(db.mysql.grt PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")

  cotire(db.mysql.grt)
endif()

install(TARGETS db.mysql.grt DESTINATION ${WB_PYTHON_MODULES_DIR})  #TODO: Is this where it should go?

=== res/sqlidedata/CMakeLists.txt ===
set(DATA_FILES 
    templates/CSV.pre.tpl
    templates/CSV.tpl
    templates/CSV.tpli
    templates/CSV_semicolon.pre.tpl
    templates/CSV_semicolon.tpl
    templates/CSV_semicolon.tpli
    templates/HTML.post.tpl
    templates/HTML.pre.tpl
    templates/HTML.tpl
    templates/HTML.tpli
    templates/SQL_inserts.pre.tpl
    templates/SQL_inserts.tpl
    templates/SQL_inserts.tpli
    templates/tab.pre.tpl
    templates/tab.tpl
    templates/tab.tpli
    templates/XLS.post.tpl
    templates/XLS.pre.tpl
    templates/XLS.tpl
    templates/XLS.tpli
    templates/XML.post.tpl
    templates/XML.pre.tpl
    templates/XML.tpl
    templates/XML.tpli
    templates/XML_mysql.post.tpl
    templates/XML_mysql.pre.tpl
    templates/XML_mysql.tpl
    templates/XML_mysql.tpli
    templates/JSON.post.tpl
    templates/JSON.pre.tpl
    templates/JSON.tpl
    templates/JSON.tpli
	
	context-help/help-5.5.json
	context-help/help-5.6.json
	context-help/help-5.7.json
	context-help/help-8.0.json
)

install(FILES ${DATA_FILES} DESTINATION ${WB_PACKAGE_SHARED_DIR}/modules/data/sqlide)

=== tools/mga/CMakeLists.txt ===
# Copyright (c) 2017, 2018, Oracle and/or its affiliates. All rights reserved.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; version 2 of the
# License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
# 02110-1301  USA


# -*- mode:cmake -*-
cmake_minimum_required (VERSION 2.8)

# Detect build type, fallback to release and throw a warning if use didn't specify any
if(NOT CMAKE_BUILD_TYPE)
  message(WARNING "Build type not set, falling back to Release mode.
 To specify build type use:
 -DCMAKE_BUILD_TYPE=<mode> where <mode> is Debug or Release.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
       "Choose the type of build, options are: Debug Release."
       FORCE)
endif(NOT CMAKE_BUILD_TYPE)

option(WITH_LIBCXX "Building with clang++ and libc++(in Linux). To enable with: -DWITH_LIBCXX=On" On)

project(MGA)

if(CMAKE_VERSION VERSION_EQUAL "3.0.0" OR
   CMAKE_VERSION VERSION_GREATER "3.0.0")
  CMAKE_POLICY(SET CMP0045 OLD)
  CMAKE_POLICY(SET CMP0042 OLD)
endif()

if(CMAKE_VERSION VERSION_EQUAL "3.3.0" OR
   CMAKE_VERSION VERSION_GREATER "3.3.0")
  CMAKE_POLICY(SET CMP0059 OLD)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")
find_package(MySQLCppConn 1.1.8 REQUIRED)
find_package(OpenSSL REQUIRED)
find_package (Threads)

set(CMAKE_OSX_SYSROOT /Applications/Xcode.app/Contents/Developer/Platforms/MacOSX.platform/Developer/SDKs/MacOSX10.13.sdk)
set(CMAKE_OSX_DEPLOYMENT_TARGET "10.11")

if(UNIX AND NOT APPLE)
  find_package(PkgConfig REQUIRED)
  find_package(X11 REQUIRED)
  pkg_check_modules(GLIB2 REQUIRED glib-2.0>=2.30)
  pkg_check_modules(ATSPI REQUIRED atspi-2)
  pkg_check_modules(GLIBMM REQUIRED glibmm-2.4>=2.46)
  pkg_check_modules(GIOMM REQUIRED giomm-2.4>=2.46)
  pkg_check_modules(CAIROMM REQUIRED cairomm-1.0>=1.12)
  pkg_check_modules(GTKMM REQUIRED gtkmm-3.0>=3.18)
elseif(APPLE)
  find_library(Cocoa_LIBRARIES Cocoa)
  find_library(COREFOUNDATION_LIBRARY CoreFoundation)
endif()

file(STRINGS "version.txt" MGA_VERSION)

# Add some common compiler flags. TODO: Shouldn't this be done checking if whatever compiler
# we use supports each flag to allow for non-gcc compilers in Linux (as above)?
set(MGA_CXXFLAGS -Werror -Wall -Wextra -Wno-unused-parameter -Wno-deprecated)

if(BUILD_WITH_COVERAGE AND UNIX)
  message (STATUS "Enable coverage support due to BUILD_WITH_COVERAGE")
  set(MGA_CXXFLAGS ${MGA_CXXFLAGS} --coverage)
endif()

if("${CMAKE_VERSION}" VERSION_GREATER 3.1.0)
  set(CMAKE_CXX_STANDARD 14)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)
	if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang" AND CMAKE_SYSTEM_NAME MATCHES "Linux" AND WITH_LIBCXX)
  	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
	endif()
else()
	if ("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
			execute_process(
					COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
			# Just g++-5.0 and greater contain <codecvt> header. (test in ubuntu)
			if (NOT (GCC_VERSION VERSION_GREATER 5.4 OR GCC_VERSION VERSION_EQUAL 5.4))
					message(FATAL_ERROR "${PROJECT_NAME} requires g++ 5.4 or greater.")
			endif ()
	elseif ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang" AND APPLE)
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
	elseif ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang" AND CMAKE_SYSTEM_NAME MATCHES "Linux")
			execute_process(
					COMMAND ${CMAKE_CXX_COMPILER} -dumpversion OUTPUT_VARIABLE CLANG_VERSION)
			if (NOT (CLANG_VERSION VERSION_GREATER 4.2.1 OR CLANG_VERSION VERSION_EQUAL 4.2.1))
					message(FATAL_ERROR "${PROJECT_NAME} requires clang 4.2.1 or greater.")
			endif ()
			# You can use libc++ to compile this project when g++ is NOT greater than or equal to 5.0.
			if (WITH_LIBCXX)
					set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -stdlib=libc++")
			endif()
	else ()
			message(FATAL_ERROR "Your C++ compiler does not support C++14.")
	endif ()
endif()

##
## Installation location
##
set(INSTALL_BINDIR "bin")
set(INSTALL_LIBDIR "lib/mga")
set(INSTALL_INCLUDEDIR "include/mga")
set(INSTALL_SHAREDIR "share/mga")
set(INSTALL_DOCDIR "share/doc/mga")

add_subdirectory(src)

if(EXISTS LICENSE.txt)
  install(FILES LICENSE.txt
          DESTINATION ${INSTALL_DOCDIR})
endif()

install(FILES VERSION 
      DESTINATION ${INSTALL_DOCDIR})

=== ext/scintilla/gtk/CMakeLists.txt ===
set(SCINTILLA_SOURCES
    scintilla-marshal.c
    PlatGTK.cxx
    ScintillaGTK.cxx
    ScintillaGTKAccessible.cxx
    ../src/AutoComplete.cxx
    ../src/CallTip.cxx
    ../src/CaseConvert.cxx
    ../src/CaseFolder.cxx
    ../src/Catalogue.cxx
    ../src/CellBuffer.cxx
    ../src/CharClassify.cxx
    ../src/ContractionState.cxx
    ../src/Decoration.cxx
    ../src/Document.cxx
    ../src/EditModel.cxx
    ../src/Editor.cxx
    ../src/EditView.cxx
    ../src/ExternalLexer.cxx
    ../src/Indicator.cxx
    ../src/KeyMap.cxx
    ../src/LineMarker.cxx
    ../src/MarginView.cxx
    ../src/PerLine.cxx
    ../src/PositionCache.cxx
    ../src/RESearch.cxx
    ../src/RunStyles.cxx
    ../src/ScintillaBase.cxx
    ../src/Selection.cxx
    ../src/Style.cxx
    ../src/UniConversion.cxx
    ../src/ViewStyle.cxx
    ../src/XPM.cxx
    ../lexlib/Accessor.cxx
    ../lexlib/CharacterCategory.cxx
    ../lexlib/CharacterSet.cxx
    ../lexlib/LexerBase.cxx
    ../lexlib/LexerModule.cxx
    ../lexlib/LexerNoExceptions.cxx
    ../lexlib/LexerSimple.cxx
    ../lexlib/PropSetSimple.cxx
    ../lexlib/StyleContext.cxx
    ../lexlib/WordList.cxx
    ../lexers/LexA68k.cxx
    ../lexers/LexAbaqus.cxx
    ../lexers/LexAda.cxx
    ../lexers/LexAPDL.cxx
    ../lexers/LexAsm.cxx
    ../lexers/LexAsn1.cxx
    ../lexers/LexASY.cxx
    ../lexers/LexAU3.cxx
    ../lexers/LexAVE.cxx
    ../lexers/LexAVS.cxx
    ../lexers/LexBaan.cxx
    ../lexers/LexBash.cxx
    ../lexers/LexBasic.cxx
    ../lexers/LexBatch.cxx
    ../lexers/LexBibTeX.cxx
    ../lexers/LexBullant.cxx
    ../lexers/LexCaml.cxx
    ../lexers/LexCLW.cxx
    ../lexers/LexCmake.cxx
    ../lexers/LexCOBOL.cxx
    ../lexers/LexCoffeeScript.cxx
    ../lexers/LexConf.cxx
    ../lexers/LexCPP.cxx
    ../lexers/LexCrontab.cxx
    ../lexers/LexCsound.cxx
    ../lexers/LexCSS.cxx
    ../lexers/LexD.cxx
    ../lexers/LexDiff.cxx
    ../lexers/LexDMAP.cxx
    ../lexers/LexDMIS.cxx
    ../lexers/LexECL.cxx
    ../lexers/LexEDIFACT.cxx
    ../lexers/LexEiffel.cxx
    ../lexers/LexErlang.cxx
    ../lexers/LexErrorList.cxx
    ../lexers/LexEScript.cxx
    ../lexers/LexFlagship.cxx
    ../lexers/LexForth.cxx
    ../lexers/LexFortran.cxx
    ../lexers/LexGAP.cxx
    ../lexers/LexGui4Cli.cxx
    ../lexers/LexHaskell.cxx
    ../lexers/LexHex.cxx
    ../lexers/LexHTML.cxx
    ../lexers/LexInno.cxx
    ../lexers/LexJSON.cxx
    ../lexers/LexKix.cxx
    ../lexers/LexKVIrc.cxx
    ../lexers/LexLaTeX.cxx
    ../lexers/LexLisp.cxx
    ../lexers/LexLout.cxx
    ../lexers/LexLua.cxx
    ../lexers/LexMagik.cxx
    ../lexers/LexMake.cxx
    ../lexers/LexMarkdown.cxx
    ../lexers/LexMatlab.cxx
    ../lexers/LexMetapost.cxx
    ../lexers/LexMMIXAL.cxx
    ../lexers/LexModula.cxx
    ../lexers/LexMPT.cxx
    ../lexers/LexMSSQL.cxx
    ../lexers/LexMySQL.cxx
    ../lexers/LexNimrod.cxx
    ../lexers/LexNsis.cxx
    ../lexers/LexNull.cxx
    ../lexers/LexOpal.cxx
    ../lexers/LexOScript.cxx
    ../lexers/LexPascal.cxx
    ../lexers/LexPB.cxx
    ../lexers/LexPerl.cxx
    ../lexers/LexPLM.cxx
    ../lexers/LexPO.cxx
    ../lexers/LexPOV.cxx
    ../lexers/LexPowerPro.cxx
    ../lexers/LexPowerShell.cxx
    ../lexers/LexProgress.cxx
    ../lexers/LexProps.cxx
    ../lexers/LexPS.cxx
    ../lexers/LexPython.cxx
    ../lexers/LexR.cxx
    ../lexers/LexRebol.cxx
    ../lexers/LexRegistry.cxx
    ../lexers/LexRuby.cxx
    ../lexers/LexRust.cxx
    ../lexers/LexScriptol.cxx
    ../lexers/LexSmalltalk.cxx
    ../lexers/LexSML.cxx
    ../lexers/LexSorcus.cxx
    ../lexers/LexSpecman.cxx
    ../lexers/LexSpice.cxx
    ../lexers/LexSQL.cxx
    ../lexers/LexSTTXT.cxx
    ../lexers/LexTACL.cxx
    ../lexers/LexTADS3.cxx
    ../lexers/LexTAL.cxx
    ../lexers/LexTCL.cxx
    ../lexers/LexTCMD.cxx
    ../lexers/LexTeX.cxx
    ../lexers/LexTxt2tags.cxx
    ../lexers/LexVB.cxx
    ../lexers/LexVerilog.cxx
    ../lexers/LexVHDL.cxx
    ../lexers/LexVisualProlog.cxx
    ../lexers/LexYAML.cxx
)

add_library(wbscintilla
  ${SCINTILLA_SOURCES})

target_include_directories(wbscintilla
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/../include
    ${CMAKE_CURRENT_SOURCE_DIR}/../lexlib
    ${CMAKE_CURRENT_SOURCE_DIR}/../src
)

target_include_directories(wbscintilla
  SYSTEM
  PRIVATE
    ${GTK3_INCLUDE_DIRS}
)

add_library(wbscintilla_Iface INTERFACE)
add_library(wbscintilla::wbscintilla ALIAS wbscintilla_Iface)
target_include_directories(wbscintilla_Iface INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
)


set(SCI_VERSION_FILE ../win32/ScintRes.rc)
file(STRINGS ${SCI_VERSION_FILE} SCI_VERSION_LINE REGEX "#define VERSION_SCINTILLA \"[0-9.]+\"")
if (SCI_VERSION_LINE)
  string(REGEX MATCH "([0-9.]+)" SCI_VERSION "${SCI_VERSION_LINE}")
  message("Found Scintilla Version: " ${SCI_VERSION})
else()
  message(ERROR " Unable to detect Scintilla version")
endif()

set(NEW_WB_CFLAGS ${WB_CFLAGS})
list(REMOVE_ITEM NEW_WB_CFLAGS -Werror)
list(APPEND NEW_WB_CFLAGS -DGTK -DSCI_LEXER -DSCI_NAMESPACE -Wno-deprecated-register -Wno-implicit-fallthrough)
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
  list(APPEND NEW_WB_CFLAGS -DNO_CXX11_REGEX)
endif()
target_compile_options(wbscintilla PRIVATE ${NEW_WB_CFLAGS})
target_link_libraries(wbscintilla PUBLIC wbscintilla_Iface PRIVATE ${GTK3_LIBRARIES})

if(BUILD_FOR_GCOV)
  target_link_libraries(wbscintilla PRIVATE gcov)
endif()

set_target_properties(wbscintilla
                      PROPERTIES VERSION   ${SCI_VERSION}
                      SOVERSION ${SCI_VERSION})


if(COMMAND cotire)
    set_target_properties(wbscintilla PROPERTIES
        COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")
    
  cotire(wbscintilla)
endif()

install(TARGETS wbscintilla DESTINATION ${WB_INSTALL_LIB_DIR})

=== library/forms/swig/CMakeLists.txt ===
execute_process(COMMAND ${CMAKE_CXX_COMPILER} -dumpversion
                OUTPUT_VARIABLE GCC_VERSION)
set(MODULE_DATA_FILES
    ${CMAKE_BINARY_DIR}/library/forms/swig/mforms.py
    ${CMAKE_BINARY_DIR}/library/forms/swig/cairo.py
)

install(FILES ${MODULE_DATA_FILES} DESTINATION ${WB_PYTHON_MODULES_DIR})

set(SWIG_MODULE_mforms_EXTRA_DEPS
    ${PROJECT_SOURCE_DIR}/library/base/base/drawing.h
    ${PROJECT_SOURCE_DIR}/library/base/base/log.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/view.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/form.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/button.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/checkbox.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/textentry.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/textbox.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/label.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/selector.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/listbox.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/tabview.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/box.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/panel.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/filechooser.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/radiobutton.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/imagebox.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/progressbar.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/table.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/scrollpanel.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/wizard.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/drawbox.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/tabswitcher.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/app.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/appview.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/utilities.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/uistyle.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/appview.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/sectionbox.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/widgets.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/menu.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/splitter.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/popup.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/code_editor.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/menubar.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/toolbar.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/task_sidebar.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/hypertext.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/popover.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/fs_object_selector.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/simpleform.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/treeview.h
    ${PROJECT_SOURCE_DIR}/library/forms/mforms/dockingpoint.h
    ${PROJECT_SOURCE_DIR}/library/forms/swig/mforms_grt.h
    ${PROJECT_SOURCE_DIR}/library/forms/swig/mforms_drawbox.h
)

set(CMAKE_SWIG_FLAGS -w312)
set_source_files_properties(cairo.i PROPERTIES CPLUSPLUS ON)
set_property(SOURCE cairo.i PROPERTY SWIG_FLAGS -DCAIRO_HAS_PNG_FUNCTIONS=1 -fcompact -DSWIG_PYTHON_LEGACY_BOOL -I/usr/include)
if(CMAKE_VERSION VERSION_LESS 3.8)
  swig_add_module(cairo python cairo.i)
else()
  swig_add_library(cairo LANGUAGE python SOURCES cairo.i)
endif()
swig_link_libraries(cairo ${CAIRO_LIBRARIES})

target_include_directories(_cairo 
 SYSTEM
  PRIVATE
    ${PYTHON_INCLUDE_DIRS}
)

if (("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") AND (GCC_VERSION VERSION_GREATER 4.6 OR GCC_VERSION VERSION_EQUAL 4.6))
  target_compile_options(_cairo PRIVATE -Wno-unused-but-set-variable)
endif()
if (GCC_VERSION)
  target_compile_options(_cairo PRIVATE -Wno-error)
endif()

target_compile_options(_cairo PRIVATE ${WB_CXXFLAGS})

set(SOURCE_FILE_COMPILE_FLAGS "-Wno-missing-field-initializers -Wno-parentheses")
if(CMAKE_COMPILER_IS_GNUCXX)
  set(SOURCE_FILE_COMPILE_FLAGS "${SOURCE_FILE_COMPILE_FLAGS} -Wno-maybe-uninitialized -Wno-stringop-truncation -Wno-cast-function-type")
endif()

set_source_files_properties(${swig_generated_file_fullname} PROPERTIES COMPILE_FLAGS ${SOURCE_FILE_COMPILE_FLAGS})

set(CMAKE_SWIG_FLAGS -w401,402,509)
set_source_files_properties(mforms.i PROPERTIES CPLUSPLUS ON)
set_property(SOURCE mforms.i PROPERTY SWIG_FLAGS -w512 -fvirtual -DSWIG_PYTHON_LEGACY_BOOL)
if(CMAKE_VERSION VERSION_LESS 3.8)
  swig_add_module(mforms python mforms.i)
else()
  swig_add_library(mforms LANGUAGE python SOURCES mforms.i)
endif()
swig_link_libraries(mforms Boost::boost mforms wbscintilla wbbase::wbbase wbpublic::wbpublic grt::grt ${GTK3_LIBRARIES} ${LIBXML2_LIBRARIES})
set_source_files_properties(${swig_generated_file_fullname} PROPERTIES COMPILE_FLAGS ${SOURCE_FILE_COMPILE_FLAGS})

target_compile_options(_mforms PRIVATE ${WB_CXXFLAGS})

target_include_directories(_mforms 
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${PROJECT_SOURCE_DIR}/generated
)

target_include_directories(_mforms 
 SYSTEM
  PRIVATE
    ${PYTHON_INCLUDE_DIRS}
)


if (("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU") AND (GCC_VERSION VERSION_GREATER 4.6 OR GCC_VERSION VERSION_EQUAL 4.6))
  target_compile_options(_mforms PRIVATE -Wno-unused-but-set-variable)
endif()
if (GCC_VERSION)
  target_compile_options(_mforms PRIVATE -Wno-error)
endif()

set_target_properties(_mforms
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

target_compile_options(_cairo PUBLIC ${WB_CXXFLAGS})

set_target_properties(_cairo
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})

if(BUILD_FOR_GCOV)
  target_link_libraries(_cairo gcov)
  target_link_libraries(_mforms gcov)
endif()                                 
                                 
install(TARGETS _mforms _cairo DESTINATION ${WB_PYTHON_MODULES_DIR})

=== library/sql.parser/source/CMakeLists.txt ===
add_library(sqlparser
    charset-def.cpp
    charset.cpp
    ctype-big5.cpp
    ctype-bin.cpp
    ctype-cp932.cpp
    ctype-czech.cpp
    ctype-eucjpms.cpp
    ctype-euc_kr.cpp
    ctype-extra.cpp
    ctype-gb2312.cpp
    ctype-gbk.cpp
    ctype-latin1.cpp
    ctype-mb.cpp
    ctype-simple.cpp
    ctype-sjis.cpp
    ctype-tis620.cpp
    ctype-uca.cpp
    ctype-ucs2.cpp
    ctype-ujis.cpp
    ctype-utf8.cpp
    ctype-win1250ch.cpp
    ctype.cpp
    int2str.cpp
    myx_lex_helpers.cpp
    myx_sql_tree_item.cpp
    myx_statement_parser.cpp
    myx_unicode_scanner.cpp
    sql_parser_symbols.cpp
    my_messnc.cpp
    my_static.cpp
    my_strtoll10.cpp
    my_vsnprintf.cpp
    my_lib.cpp
    strmake.cpp
    strnmov.cpp
    strtod.cpp
    strxmov.cpp
    str_alloc.cpp
    linux/myx_sql_parser.cpp
    xml.cpp
)

target_include_directories(sqlparser
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:$<$<PLATFORM_ID:Linux>:${CMAKE_CURRENT_SOURCE_DIR}/linux>>
  PRIVATE
    $<$<PLATFORM_ID:Linux>:${CMAKE_CURRENT_SOURCE_DIR}/linux>
)

if (UNIX)
  target_compile_definitions(sqlparser PRIVATE -DHAVE_MEMCPY=1 -DHAVE_MEMMOVE=1 -DUSE_MB=1 -DUSE_MB_IDENT=1 -DHAVE_STRTOUL=1)
endif ()

target_link_libraries(sqlparser PUBLIC db.mysql.sqlparser.grt::db.mysql.sqlparser.grt)

if(BUILD_FOR_GCOV)
  target_link_libraries(sqlparser PRIVATE gcov)
endif()


set_source_files_properties(myx_sql_tree_item.cpp PROPERTIES COMPILE_FLAGS -Wno-varargs)
set_source_files_properties(myx_unicode_scanner.cpp PROPERTIES COMPILE_FLAGS "-Wno-empty-body -Wno-pragmas -Wno-implicit-fallthrough")
set_source_files_properties(ctype-utf8.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)
set_source_files_properties(myx_statement_parser.cpp PROPERTIES COMPILE_FLAGS -Wno-implicit-fallthrough)

target_compile_options(sqlparser PRIVATE ${WB_CXXFLAGS})

set_target_properties(sqlparser
                      PROPERTIES VERSION   ${WB_VERSION}
                                 SOVERSION ${WB_VERSION})
if(COMMAND cotire)
  set_target_properties(sqlparser PROPERTIES 
      COTIRE_ENABLE_PRECOMPILED_HEADER FALSE
      COTIRE_ADD_UNITY_BUILD FALSE
      COTIRE_PREFIX_HEADER_IGNORE_PATH "${PRECOMPILED_HEADERS_EXCLUDE_PATHS}")
    cotire(sqlparser)
endif()
install(TARGETS sqlparser DESTINATION ${WB_INSTALL_LIB_DIR})

=== debian/changelog ===
mysql-workbench (8.0.17+dfsg-1ubuntu2) eoan; urgency=medium

  [ Lars Tangvald ]
  * d/patches: Fix for building with MySQL
    - Disabled Werror compilation flag
      Upstream uses the flag to catch new warnings, but it will tend to
      cause build failures.

 -- Robie Basak <robie.basak@ubuntu.com>  Fri, 27 Sep 2019 15:42:05 +0100

mysql-workbench (8.0.17+dfsg-1ubuntu1) eoan; urgency=medium

  * d/patches: Fix for building with MySQL
    - Disabled all MariaDB-specific patches
    - Disabled new gcc 9.1 warnings pending upstream fix

 -- Lars Tangvald <lars.tangvald@oracle.com>  Fri, 16 Aug 2019 08:46:51 +0200

mysql-workbench (8.0.17+dfsg-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * New upstream release.
  * Fixed:
    + CVE-2018-2598 (Closes: #904112).
    + gnome-keyring --> libsecret (Closes: #867943, #769393).
    + FTBFS (Closes: #910052, #914761).
      Thanks, Andrius Merkys.
    + "Alter table crashes Workbench" (Closes: #871775).
    + "Cannot satisfy the gdal-abi-2-3-0 dependency" (Closes: #923729).
  * New patch to fix FTBFS on x86_32.
  * Standards-Version: 4.4.0.
  * debhelper & compat to version 12
  * Build-Depends:
    - libgnome-keyring-dev
    + libsecret-1-dev
    - antlr3
    + antlr4 (>= 4.6~)
    + libssh-dev (>= 0.8.1~)
    + default-jre-headless
    + libantlr4-runtime-dev

  [ Andrius Merkys ]
  * antlr-runtime is no longer present in upstream tarball.
  * Ceasing to exclude files under ext/scintilla/win32 as they seem to be
    required for CMake.
  * Fixing d/watch to exclude terminal '.' from extracted upstream version.
  * Extending patch mariadb-build.patch to cover WB_BOOL definition and
    handle MAX_NO_FIELD_TYPES enum value.
  * MariaDB now supports MYSQL_TYPE_JSON.
  * d/mysql-workbench-data.docs: README was renamed to README.md by upstream.
  * d/control: adding b-dep on "libantlr4-runtime-dev".
  * Improved descriptions in d/control.
  * Removing unused lintian override d/mysql-workbench-data.lintian-overrides.
  * Adding d/s/lintian-overrides to ignore 'duplicate word' warning.

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 03 Aug 2019 13:22:16 +1000

=== debian/control ===
Source: mysql-workbench
Section: database
Priority: optional
Standards-Version: 4.4.0
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Mateusz Kijowski <mateusz.kijowski@gmail.com>
Build-Depends: debhelper (>= 12~) ,dh-python
    ,g++-8
 ,cmake ,perl
 ,autoconf ,automake ,libtool
 ,bison ,flex ,swig
 ,doxygen
 ,gettext
 ,antlr4 (>= 4.6~)
 ,libantlr4-runtime-dev
 ,libboost-dev
 ,libcairo2-dev
 ,libctemplate-dev
 ,libfreetype6-dev
 ,libgdal-dev
 ,libgl1-mesa-dev
 ,libglib2.0-dev
# ,libgnome-keyring-dev
    ,libsecret-1-dev
    ,libssh-dev (>= 0.8.1~)
###    ,libssh2-1-dev (>= 1.8.0~)
    ,default-jre-headless
 ,libgtk-3-dev
 ,libgtkmm-3.0-dev
 ,liblua5.1-0-dev
 ,libmysqlcppconn-dev (>= 1.1.12~)
 ,libpng-dev
 ,default-libmysqlclient-dev
 ,libpcre3-dev
 ,libpixman-1-dev
 ,libsqlite3-dev
 ,libtinyxml-dev (>= 2.6.2)
 ,libvsqlitepp-dev
 ,libxml2-dev
 ,libzip-dev
 ,python-dev
 ,python-paramiko
 ,unixodbc-dev
 ,uuid-dev
 ,xdg-utils
Homepage: http://dev.mysql.com/workbench/
Vcs-Browser: https://salsa.debian.org/debian/mysql-workbench
Vcs-Git: https://salsa.debian.org/debian/mysql-workbench.git

Package: mysql-workbench
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}
 ,mysql-workbench-data (= ${source:Version})
 ,python-mysql.connector
 ,python-paramiko
 ,python-pexpect
 ,python-pyodbc (>= 2.1.8)
 ,python-pysqlite2
Recommends: ttf-bitstream-vera, mysql-utilities
           ,default-mysql-client | virtual-mysql-client
#Suggests: gnome-keyring
Description: MySQL Workbench - a visual database modeling, administration and queuing tool
 MySQL Workbench is a modeling tool that allows one to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.

Package: mysql-workbench-data
Architecture: all
Depends: ${misc:Depends}
Description: MySQL Workbench -- architecture independent data
 MySQL Workbench is a modeling tool that allows one to design
 and generate MySQL databases graphically. It also has administration
 and query development modules where you can manage MySQL server instances
 and execute SQL queries.
 .
 This package provides architecture independent files

#Package: mysql-workbench-docs
#Architecture: all
#Depends: ${misc:Depends}, libjs-jquery
#Recommends: yelp
#Suggests: www-browser
#Section: doc
#Description: MySQL Workbench -- Documentation for developers
# MySQL Workbench is a modeling tool that allow to design
# and generate MySQL databases graphically. It also has administration
# and query development modules where you can manage MySQL server instances
# and execute SQL queries.
# .
# This package provides documentation for developers

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

## "bindnow" causes run-time errors:
#export DEB_BUILD_MAINT_OPTIONS=hardening=+bindnow

# minimise needless linking
export DEB_LDFLAGS_MAINT_APPEND= -Wl,--as-needed

export DEB_CPPFLAGS_MAINT_APPEND= -std=c++11 -Wno-error=deprecated-declarations
# -std=c++11
# -Wno-deprecated-copy

export ANTLR_JAR_PATH=/usr/share/java/antlr4.jar

MAX_PARALLEL=--max-parallel=3

%:
	dh $@ $(MAX_PARALLEL) --with python2

override_dh_clean:
	$(RM) -rv CMakeFiles ext/antlr-runtime/.libs
	dh_clean

override_dh_auto_configure:
	dh_auto_configure -- \
            -DUSE_UNIXODBC=ON \
            -DCMAKE_INSTALL_PREFIX=/usr \
            -DWITH_ANTLR_JAR=${ANTLR_JAR_PATH} \
            -DANTLR4_INCLUDE_DIRS="/usr/include/antlr4-runtime" \
            -DREAL_EXECUTABLE_DIR=/usr/lib/$(DEB_SOURCE) \
        ;

#            -DOpenGL_GL_PREFERENCE=GLVND \

override_dh_auto_build:
	# rebuild files generated by flex/bison
	cd library/sql.parser/yy_gen-tool/yy_gen-tool/ \
        && bison -dl parser.yy \
        && flex -B -oparser.lex.cc parser.lex
	cd library/parsers/grammars \
        && antlr4 -Dlanguage=Cpp -listener -visitor -o ../mysql -package parsers MySQLLexer.g4 MySQLParser.g4
	# generate documentation for mysql-workbench-docs package
	#cd doc && ./DoxygenRun.sh
	# build all the rest
	dh_auto_build $(MAX_PARALLEL)

override_dh_auto_install:
	dh_auto_install $(MAX_PARALLEL) --destdir=$(CURDIR)/debian/tmp
	# .desktop to unix line endings
	sed -i 's/\r//g' debian/tmp/usr/share/applications/*.desktop
	# remove *.la files
	find . -name '*.la' -delete -printf 'removing %p\n'
	# install link to launcher to /usr/bin/
	dh_link -p$(DEB_SOURCE) \
            usr/lib/$(DEB_SOURCE)/mysql-workbench usr/bin/mysql-workbench

override_dh_python2:
	dh_python2 --no-ext-rename

override_dh_compress:
	dh_compress --exclude=.mwb

override_dh_makeshlibs:
	dh_makeshlibs --noscripts

# help `dh_shlibdeps` to find local libraries: 'dpkg-shlibdeps: error: couldn't find library'
override_dh_shlibdeps:
	dh_shlibdeps -l /usr/lib/$(DEB_SOURCE):/usr/lib/$(DEB_SOURCE)/plugins:$(LD_LIBRARY_PATH)

## semi-automated manpage generation (to invoke manually)
MAN_NAME=mysql-workbench \\- MySQL Database Design, Administration and Development Tool
mysql-workbench.1:
	help2man --no-info --manual="mysql-workbench" --name="$(MAN_NAME)" mysql-workbench > $@
	perl \
            -E 's{^.*?\s+\\-\s+mysql-workbench.*}{$(MAN_NAME)}; # correcting NAME section'     \
            -E 's{^\.SH DESCRIPTION}{.SH SYNOPSIS};             # correcting SYNOPSIS section' \
            -E 's{^mysql\\-workbench\K\\-bin}{};                # correcting executable name'  \
            -E 's{^Options:}{.SH OPTIONS};                      # create OPTIONS section'      \
            -pi $@

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
repacksuffix=+dfsg,\
repack,compression=xz,\
pgpsigurlmangle=s{$}{.asc},\
dversionmangle=s{\+dfsg\d*}{},\
uversionmangle=s{\.?\-rc}{~rc},\
" https://www.mirrorservice.org/sites/ftp.mysql.com/Downloads/MySQLGUITools\
  /mysql-workbench-community-([\d\.]+)(?:\-rc\d*)?(?:-nodocs)?-src\.tar\.(?:gz|bz2|xz)
